<!DOCTYPE html>
<html lang="fr">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Click on the task to execute</title>
    <style>
        .checkbox-column {
            float: left;
            width: 33%;
            border: 1px solid #ccc; /* Bordure de la colonne */
            box-sizing: border-box; /* Pour inclure la bordure dans la largeur de la colonne */
            padding: 10px; /* Espacement autour des cases à cocher */
        }

        .optobox-title {
            border: 2px solid #ccc; /* Bordure bleue autour du troisième optobox */
            padding: 8px; /* Espacement à l'intérieur de la bordure */
            margin-bottom: 7px; /* Espacement entre les optobox */
            width: 94%;
            display: block;
            text-align: center;
        }

        .title {
            border: 2px solid black; /* Bordure bleue autour du titre */
            padding: 8px; /* Espacement à l'intérieur de la bordure */
            margin-bottom: 10px; /* Espacement entre le titre et les optobox */
            text-align: center; /* Centrer le texte */
        }
    </style>
</head>
<body>
    <h1 class="title">Optoboxes</h1>
    <h2>Click on the task to execute :</h2>
    <ul>
        <li><a href="/health">Health</a></li>
        <li><a href="/add">Add</a></li>
        <li><a href="/minus">Minus</a></li>
        <li><a href="/write">Write</a></li>
        <li><a href="/state">State</a></li>
        <li><a href="/shutdown">Shutdown</a></li>
    </ul>
    

    <h2>Queues:</h2>
    <input type="checkbox" id="all" name="queue" value="all">
    <label for="all">All</label><br>

    <!-- Script pour générer le formulaire dynamique -->
    <script>
        var obox_num = 3;
        var oboard_num = 6; 

        function generateDynamicForm() {
            var formHTML = '<form id="queueForm">';
            for (var i = 1; i <= obox_num; i++) {
                formHTML += '<div class="checkbox-column">';
                formHTML += '<label class="optobox-title" for="optobox' + i + '"> Optobox ' + i + '</label><br>';
                formHTML += '<input type="checkbox" id="optobox' + i + '_all" name="queue" value="optobox' + i + '_all">';
                formHTML += '<label for="optobox' + i + '_all">All Optobox ' + i + ' Queues</label><br>';
                formHTML += '<hr>';
                for (var j = 1; j <= oboard_num; j++) {
                    formHTML += '<input type="checkbox" id="optobox' + i + '_optoboard' + j + '_queue" name="queue" value="optobox' + i + '_optoboard' + j + '_queue">';
                    formHTML += '<label for="optobox' + i + '_optoboard' + j + '_queue">Optoboard ' + j + '</label><br>';
                }
                formHTML += '</div>';
            }
            formHTML += '</form>';
            return formHTML;
        }

        document.write(generateDynamicForm());
    </script>

    <script>
        function extractNumbers(checkboxValue) {
            const oboard = checkboxValue.match(/optobox(\d+)_optoboard(\d+)_queue/);
            const obox = checkboxValue.match(/optobox(\d+)_all/);
            const all = checkboxValue.match(/all/);
            if (oboard) {
                const optoboxNum = oboard[1];
                const optoboardNum = oboard[2];
                return { optoboxNum, optoboardNum };
            }
            else if (obox){
                const optoboxNum = obox[1];
                const optoboardNum = 0;

                return { optoboxNum};

            }
            else{
                const optoboxNum = 0;
                const optoboardNum = 0;

                return {optoboxNum};
            }
        }
    
        // Function to handle task execution
        function executeTask(taskLink) {
            const checkedBoxes = document.querySelectorAll('input[name="queue"]:checked');
            if (checkedBoxes.length === 0) {
                alert("Please select a queue before executing the task.");
                return;
            }
    
            const selectedQueues = [];
            checkedBoxes.forEach(checkbox => {
                const numbers = extractNumbers(checkbox.value);
                if (numbers) {
                    selectedQueues.push(numbers);
                }
            });
    
            if (selectedQueues.length === 0) {
                alert("No valid queue selected.");
                return;
            }
    
            let taskURL = taskLink.getAttribute('href');
            let taskName = taskURL.substring(taskURL.lastIndexOf('/') + 1); // Extract task name from URL
    
            let taskWithQueuesURL;
            const optoboxNums = selectedQueues.map(queue => queue.optoboxNum).join(",");
            const optoboardNums = selectedQueues.map(queue => queue.optoboardNum).join(",");
            if (optoboxNums == 0 ) {
                taskWithQueuesURL = `/${taskName}`;
            }
            else if (optoboardNums == 0) {
                taskWithQueuesURL = `/optobox/${optoboxNums}/${taskName}`;
            }
            else {

                taskWithQueuesURL = `/optobox/${optoboxNums}/optoboard/${optoboardNums}/${taskName}`;
            }
    
            console.log(taskWithQueuesURL);
            window.location.href = taskWithQueuesURL;
        }
    
        const taskLinks = document.querySelectorAll('a');
        taskLinks.forEach(link => {
            link.addEventListener('click', function(event) {
                event.preventDefault();
                executeTask(this);
            });
        });
    </script>
    
</body>
</html>
